const openpgp = require('openpgp');
const { S3, SSM } = require('aws-sdk');
const LendingResponse = require('../../../common-utils/lending-response/index');
const { sanitizeError } = require('../../../common-utils/lending-errors/index');

const s3 = new S3({ signatureVersion: 'v4' });
const ssm = new SSM();

const generateId = (correlationId, clientId) => `${clientId}/${correlationId}`;

const buildPublicKeyPath = (id) => `${id}/public.key`;

const generatePassword = () => Math.random().toString(36).substr(2);

const generatePgpKeys = (password) => openpgp.generateKey({
  type: 'rsa',
  rsaBits: 2048,
  userIDs: [{ name: 'Secure File Upload' }],
  passphrase: password,
  format: 'armored'
});

const generateSignedUrlForGet = (bucket, id, expires) => s3.getSignedUrlPromise('getObject', {
  Bucket: bucket,
  Key: id,
  Expires: expires  // number of seconds before the URL expires
});

const generateSignedUrlForPut = (bucket, id, expires) => s3.getSignedUrlPromise('putObject', {
  Bucket: bucket,
  Key: id,
  Expires: expires, // number of seconds before the URL expires
  ServerSideEncryption: 'aws:kms'
});

const putPublicKeyInS3 = async (bucket, key, keyPromise) => { 
  const { publicKey } = await keyPromise;
  return s3.putObject({
    Bucket: bucket,
    Key: key,
    Body: publicKey,
    ServerSideEncryption: 'aws:kms'
  }).promise();
};


const putSecretsInParameterStore = async (parameter_store, id, keysPromise, password, expires) => {
  const { privateKey } = await keysPromise;
  let expirationTime = new Date();
  expirationTime.setSeconds(expirationTime.getSeconds() + expires)
  return ssm.putParameter({
    Description: 'Generated by the upload-requests function.',
    Type: 'SecureString',
    Name: `/${parameter_store}/${id}`,
    Value: JSON.stringify({
      privateKey,
      password
    }),
    Tier: 'Advanced',
    Policies: JSON.stringify([
      {
        Type: 'Expiration',
        Version: '1.0',
        Attributes: {
          Timestamp: expirationTime.toISOString()
        }
      }
    ]),
    Tags: [
      {
        Key: 'ApplicationId',
        Value: parameter_store
      }
    ]
  }).promise();
};
exports.handler = async function (event, context) {
  return new Promise(async (resolve) => {

    const {
      headers: { clientId = '123456' } = {}
    } = event;

    const { awsRequestId: correlationId } = context;
    const {
      url_expires = 3600,
      expires = +url_expires,
      new_loans_bucket,
      parameter_store
    } = process.env;
    const password = generatePassword();
    const id = generateId(correlationId, clientId);
    const publicKeyPath = buildPublicKeyPath(id);
    const uploadUrlPromise = generateSignedUrlForPut(new_loans_bucket, `${id}/${correlationId}.gpg`, expires);
    const keysPromise = generatePgpKeys(password);
    const keyUrlPromise = putPublicKeyInS3(new_loans_bucket, publicKeyPath, keysPromise).then(() => {
      return generateSignedUrlForGet(new_loans_bucket, publicKeyPath, expires);
    });
    const putSecretInStorePromise = putSecretsInParameterStore(parameter_store, id, keysPromise, password, expires);

    return Promise.all([uploadUrlPromise, keyUrlPromise, putSecretInStorePromise])
      .then(values => {
        const result = {
          uploadUrl: values[0],
          keyUrl: values[1]
        };
        return resolve(new LendingResponse(null, result));
      })
      .catch(e => {
        return resolve(new LendingResponse(sanitizeError(e), null));
      });
  });
}